library(tm)
library(RWeka)
library(lattice) 
library(plyr)
library(dplyr)
library(text2vec)
# install.packages("igraph")
library(tidytext)
# install.packages('topicmodels')
library(topicmodels)
library(tidytext)
library(NMI)
library(tabuSearch)
library(stringr)
library(lsa)
library(foreach) 
library(doParallel) 
library(igraph) 

source("clean_evaluate.R")
# setwd("D:/Users/tomilayo/R FIles/Spring MedStar_Research/Revised PSE")
setwd("C:/Users/tomilayo/Documents/Vaccination")

Vaccine_Csv = read.csv('Vaccination_Samp.csv')
# Vaccine_Csv = read.csv('Original_Vaccine.csv')
Vaccine_Clean = read.csv('Cleaned_Vaccine.csv')
load("corr_LSA_Vaccine.RData")
customStopWords = c("a", "an", "and", "are", "as", "at", "be", "is", "it",
                    "of", "or", "that", "the", "this", "to", "was", "were",
                    "she", "he", "but", "then", "who", "they", "her", "his",
                    "has", "also", "for", "num", "time");
customStopWords2 <- c(customStopWords, "patient", "on", "in", "with", "not", "from", "by", "had",
                      "no", "nurse", "rn", "i", "when", "did", "have", "date", "physician", "there",
                      "would", "while")
txt = VectorSource(Vaccine_Clean$SYMPTOM_TEXT)
corpus2 = VCorpus(txt)
corpus2 = tm_map(corpus2,removePunctuation)
corpus2 = tm_map(corpus2, removeWords, customStopWords2)
corpus2 = tm_map(corpus2,stemDocument)
# corpus2 = tm_map(corpus2, removeWords, stopwords("en"))
# randmDoc[2]
corpus3<-tm_map(corpus2, content_transformer( function(x) clean_stemmedText(x)))
tdm.unigram_tfIDF = TermDocumentMatrix(corpus3, control = list(weighting = weightTfIdf, wordLengths=c(1,Inf)))
tdm.unigram_dat = DocumentTermMatrix(corpus3, control = list( wordLengths=c(1,Inf)))
myDf_Corpus <- data.frame(text = sapply(corpus3, paste, collapse = " "), stringsAsFactors = FALSE)
lsaSpace <- lsa((tdm.unigram_tfIDF))  # create LSA space
val2 = lsaSpace$dk #Docs  decomposed to k dimensions
dim(val2)
corr_LSA_Vaccine = cor(t(val2))
corr_LSA_Vaccine[corr_LSA_Vaccine < 0.1] = 0

dim(corr_LSA_Vaccine)
#Find the top tfidf terms
term_tfidf <-
  + tapply(tdm.unigram_dat$v/rowSums(as.matrix(tdm.unigram_dat))[tdm.unigram_dat$i], tdm.unigram_dat$j, mean) *
  + log2(ncol(corr_LSA_Vaccine)/colSums(as.matrix(tdm.unigram_dat) > 0))
terms_saved <- tdm.unigram_tfIDF$dimnames$Terms
terms_saved = cbind(terms_saved, term_tfidf)

ncores=detectCores()
cl = makeCluster(25)
registerDoParallel(cl)
start.time = proc.time()

col_num_val <- nrow(corr_LSA_Vaccine)
corr_LSA2 <- corr_LSA_Vaccine
corr_LSA2[corr_LSA2 < 0.20] <- 0
# .combine = cbind, .init=list(),
doc_Vaccine <- list()
for (ii in 1:1){
  doc_LSA_Norm_200 <- list()
  # col_order <- sample(1:col_num_val, col_num_val)
  # corr_LSA2 <- corr_LSA2[c(col_order), c(col_order)]
  # diag(corr_LSA2) <- 0.2
  for(b in 1:3){
    # b = 1
    n = 200
    if (b == 3){
      n = ncol(corr_LSA_Vaccine) - 800
    }
    V_indx <- c(1:n)
    indx_corr <- (b-1)*200 + V_indx
    corr_new <- corr_LSA2[indx_corr,indx_corr]
    grph_tmp = graph_from_adjacency_matrix(corr_new, weighted = T, mode = "undirected")
    
    V(grph_tmp)$name <- as.character(V_indx)
    sims <- 30
    max_objs_par <- list()
    res_obj_par <- list()
    doc_indx <- list()
    ind_report <- list()
    j = 1
    cnt.1 <- 0
    while (j <= 100 & n > 30 & cnt.1 < 18){
      # j <- 1
      NF = length(V_indx)
      res_config <- list()
      n <- length(V_indx)
      if(n > 30) {
        oper <- foreach(i=1:sims, .packages = c("tabuSearch", "igraph")) %dopar% {
          
          nos_1 <- sample(5:30, 1) 
          # Then generate nos_1 integers that are between 1 and size of network
          # these are the positions of initial configuration
          x <- sample(1:n, nos_1)
          mat_tmp <- matrix(0, nrow = 1, ncol = length(V_indx))
          mat_tmp[,x] = 1
          # i = 2
          # print(i)
          res <- tabuSearch(size = NF,iters = 5,objFunc = evaluate,
                            config = mat_tmp,listSize = 5,nRestarts = 4)
          res
          
        }
        for (x in 1 : sims){
          # x <- 2
          curr_obj <- which(oper[[x]]$eUtilityKeep > 0.995*max(oper[[x]]$eUtilityKeep))
          max_obj_i <- max(oper[[x]]$eUtilityKeep)
          if(x == 1){
            max_objs_par[[j]] <- max_obj_i
            doc_ind <- which(oper[[x]]$configKeep[curr_obj[1],] > 0 )
            doc_ind2 <- doc_ind
            for (m in 1:length(curr_obj)){
              # m = 25
              if(length(curr_obj) > 1){
                tmp <- which(oper[[x]]$configKeep[curr_obj[m],] > 0 )
                if (length(tmp) > length(doc_ind)) {
                  doc_ind <- tmp
                  # print(tmp)
                }
              }
            }
          } else {
            foo <- max_obj_i
            if(foo > max_objs_par[[j]]){
              max_objs_par[[j]] <- foo
              doc_ind <- which(oper[[x]]$configKeep[curr_obj[1],] > 0 )
              for (m in 1:length(curr_obj)){
                if(length(curr_obj) > 1){
                  tmp <- which(oper[[x]]$configKeep[curr_obj[m],] > 0 )
                  if (length(tmp) > length(doc_ind)) {
                    doc_ind <- tmp
                  }
                }
              }          
              
            }
          }
          
        }
        if(length(doc_ind) < 3){
          cnt.1 <- cnt.1 + 1
          V_indx <- V_indx[!(V_indx %in% V_indx[doc_ind])]
          corr_new <- corr_new[-doc_ind,-doc_ind]
          grph_tmp = graph_from_adjacency_matrix(corr_new, weighted = T, mode = "undirected")
          V(grph_tmp)$name <- as.character(V_indx)
        } else {
          # print(paste("Length of Vindx is ",length(V_indx),sep = "" ))
          doc_indx[[j]] <- V_indx[doc_ind]
          V_indx <- V_indx[!(V_indx %in% doc_indx[[j]])]
          corr_new <- corr_new[-doc_ind,-doc_ind]
          grph_tmp = graph_from_adjacency_matrix(corr_new, weighted = T, mode = "undirected")
          V(grph_tmp)$name <- as.character(V_indx)
          ind_report[[j]] <- doc_indx[[j]] + (b-1)*200 
          j = j + 1
          cnt.1 <- 0
        }
      }
      print(j)
    }
    print(b)
    doc_LSA_Norm_200[[b]] <- ind_report
  }
  doc_Vaccine[[ii]] <- doc_LSA_Norm_200
}

end.time = proc.time()
(end.time-start.time)[3]
stopCluster(cl)
# setwd("D:/Users/tomilayo/R FIles/Spring MedStar_Research/Revised PSE")
save(doc_Vaccine, file = "VaccineSim.RData")
save(corr_LSA_Vaccine, file = "corr_LSA_Vaccine.RData")

load("VaccineSim.RData")
load("corr_LSA_Vaccine.RData")

# Turn results into a table of communities and results
check_Vaccine <- indxTOcommFUN2(doc_Vaccine[[1]], corr_LSA_Vaccine, 400)
comm_tabVaccine <- as.matrix(table(check_Vaccine[,2]))
TFIDFVaccine = Vaccine_Csv[, c(1,2,10)]
# TFIDF_PSE.20$Doc = as.numeric(row.names(TFIDF_PSE.20))
TFIDFVaccine$Doc = c(1:nrow(TFIDFVaccine))
colnames(check_Vaccine) = c("Doc", "community")
TFIDFVaccine = merge(TFIDFVaccine, check_Vaccine, "Doc")

#Get mean of a community, get structure of correlation matrix
val = 2
comm_ind <- check_Vaccine[which(check_Vaccine[,2] == "79"),1]
val1 = 5
comm_ind2 <- doc_Vaccine[[1]][[1]][[val1]]
round(mean(corr_LSA_Vaccine[comm_ind2, comm_ind2]), digits = 2)
round(corr_LSA_Vaccine[comm_ind2, comm_ind2], digits = 2)
round(mean(corr_LSA_Vaccine[comm_ind2, comm_ind2]), digits = 2)



#First create new corr_Vaccine that's 400 
n_vac <- c(1:400)
corr_smallVac <- corr_LSA_Vaccine[n_vac, n_vac]
col_num_val <- ncol(corr_LSA_Vaccine)
#Then split 4 ways and make 3 simulations of each 
sampl_indx <- list()
for (i in 1:3){
  i <- 1
  sampl_indx[[i]] <- split(sample(col_num_val), rep(1:(col_num_val/300+1), each=300))
}

all_simRun <- list()
sim <- c(1:12)
for(i in 1:12){
  x <- i %% 3
  if (x == 0) {
    x <- 3
  }
  b <- ceiling(i/3)
  print(paste("This is x",x,"and b",b, sep = " "))
}
ncores=detectCores()
cl = makeCluster(25)
registerDoParallel(cl)
start.time = proc.time()
sim_all <- 4
oper <- foreach(sim_run=1:sim_all, .packages = c("tabuSearch", "igraph", "doParallel")) %dopar% {
  # sim_run <- 2
  # a <- sim_run %% 3
  # if (a == 0) {
  #   a <- 3
  # }
  a <- 1; b <- sim_run;
  # b <- ceiling(sim_run/3)
  mat_ab <- matrix(c(a,b), nrow = 2, ncol = 1)
  
  col_order <- sampl_indx[[a]][[b]]
  ind_report <- list()
  corr_LSA2 <- corr_LSA_Vaccine[c(col_order), c(col_order)]
  grph_tmp = graph_from_adjacency_matrix(corr_LSA2, weighted = T, mode = "undirected")
  n <- length(col_order)
  doc_indx <- list()
  V_indx <- col_order
  V(grph_tmp)$name <- as.character(col_order)
  sims <- 30
  j = 1
  cnt.1 <- 0
  while (j <= 60 & n > 30 & cnt.1 < 18){ #Change this to 10 & 100 just to speed up runs
    # j <- 1
    NF = length(V_indx)
    res_config <- list()
    n <- length(V_indx)
    res_store <- list()
    res_oper <- foreach(kk=1:sims, .packages = c("tabuSearch", "igraph")) %dopar% {
      nos_1 <- sample(5:30, 1) 
      # Then generate nos_1 integers that are between 1 and size of network
      # these are the positions of initial configuration
      x <- sample(1:n, nos_1)
      mat_tmp <- matrix(0, nrow = 1, ncol = length(V_indx))
      mat_tmp[,x] = 1
      # i = 2
      # print(i)
      res <- tabuSearch(size = NF,iters = 7,objFunc = evaluate,
                        config = mat_tmp,listSize = 6, nRestarts = 4)
      res
      
    }
    for (x in 1 : sims){
      # x <- 1
      curr_obj <- which(res_oper[[x]]$eUtilityKeep > 0.995*max(res_oper[[x]]$eUtilityKeep))
      max_obj_i <- max(res_oper[[x]]$eUtilityKeep)
      if(x == 1){
        max_objs_par[[j]] <- max_obj_i
        doc_ind <- which(res_oper[[x]]$configKeep[curr_obj[1],] > 0 )
        for (m in 1:length(curr_obj)){
          if(length(curr_obj) > 1){
            tmp <- which(res_oper[[x]]$configKeep[curr_obj[m],] > 0 )
            if (length(tmp) > length(doc_ind)) {
              doc_ind <- tmp
            }
          }
        }
      } else {
        foo <- max_obj_i
        if(foo > max_objs_par[[j]]){
          max_objs_par[[j]] <- foo
          doc_ind <- which(res_oper[[x]]$configKeep[curr_obj[1],] > 0 )
          for (m in 1:length(curr_obj)){
            if(length(curr_obj) > 1){
              tmp <- which(res_oper[[x]]$configKeep[curr_obj[m],] > 0 )
              if (length(tmp) > length(doc_ind)) {
                doc_ind <- tmp
              }
            }
          }          
          
        }
      }
    }
    if(length(doc_ind) < 3){
      cnt.1 <- cnt.1 + 1
      print(V_indx)
      V_indx <- V_indx[!(V_indx %in% V_indx[doc_ind])]
      ind_corr <- (colnames(corr_LSA2) %in%  V_indx)
      corr_LSA2 <- corr_LSA2[ind_corr,ind_corr]
      grph_tmp = graph_from_adjacency_matrix(corr_LSA2, weighted = T, mode = "undirected")
      V(grph_tmp)$name <- as.character(V_indx)
    } else {
      doc_indx[[j]] <- V_indx[doc_ind]
      V_indx <- V_indx[!(V_indx %in% doc_indx[[j]])]
      ind_report[[j]] <- as.numeric(colnames(corr_LSA2)[doc_ind])
      ind_corr <- (colnames(corr_LSA2) %in%  V_indx)
      corr_LSA2 <- corr_LSA2[ind_corr,ind_corr]
      grph_tmp = graph_from_adjacency_matrix(corr_LSA2, weighted = T, mode = "undirected")
      V(grph_tmp)$name <- as.character(V_indx)
      j = j + 1
      cnt.1 <- 0
    }
  }
  # all_simRun[[sim_run]] <- ind_report
  mat_ab <- matrix(c(a,b), nrow = 2, ncol = 1)
  fin_res <- list()
  fin_res[[1]] <- ind_report
  fin_res[[2]] <- mat_ab
  fin_res
}
end.time = proc.time()
(end.time-start.time)[3]
stopCluster(cl)

##--------------------------------------------------------------------------------------------------------
# 
setwd("C:/Users/tomilayo/Documents/Vaccination")

reddit_Suicide = read.csv('RedditClean.csv')
reddit_Suicide <- reddit_Suicide[-c(268), ]
customStopWords = c("a", "an", "and", "are", "as", "at", "be", "is", "it",
                    "of", "or", "that", "the", "this", "to", "was", "were",
                    "she", "he", "but", "then", "who", "they", "her", "his",
                    "has", "also", "for", "num", "time");
wrds <- as.character(c("m", "t", "ve", "s", "ll", "re", "d", "u", "isn", "o", "ive", "g", 
                       "fuck", "throwaway", "dont", "im", "gonna", "fucking", "fuckin"))

customStopWords <- c(customStopWords, wrds)
txt = VectorSource(reddit_Suicide$reddit_Txt)
corpus2 = VCorpus(txt)
corpus2 = tm_map(corpus2,removePunctuation)
corpus2 = tm_map(corpus2,stemDocument)
corpus2 = tm_map(corpus2, removeWords, customStopWords)
corpus2 = tm_map(corpus2, removeWords, stopwords("en"))
# corpus2 = tm_map(corpus2, removeWords, stopwords("en"))
# randmDoc[2]
corpus3<-tm_map(corpus2, content_transformer( function(x) clean_stemmedText(x)))
tdm.Reddit_tfIDF = TermDocumentMatrix(corpus3, control = list(weighting = weightTfIdf, wordLengths=c(1,Inf)))
myDf_Corpus <- data.frame(text = sapply(corpus3, paste, collapse = " "), stringsAsFactors = FALSE)
lsaSpace <- lsa((tdm.Reddit_tfIDF))  # create LSA space
val2 = lsaSpace$dk #Docs  decomposed to k dimensions
dim(val2)
corr_LSA_Reddit = cor(t(val2))
corr_LSA_Reddit[corr_LSA_Reddit < 0.1] = 0

# Running Tabusearch on Reddit comments
col_num_val <- nrow(corr_LSA_Reddit)
corrReddit <- corr_LSA_Reddit
corrReddit[corrReddit < 0.15] <- 0
list_reddit <- list()
cnt <- 0
for (i in 1: nrow(reddit_Suicide)){
  tmp1 <- which(corrReddit[,i] > 0.7, arr.ind = T)
  if(length(tmp1) > 3){
    cnt <- cnt + 1
    list_reddit[[cnt]] <- tmp1
  }
}
# Find groups of documents that are similar
tmp1 <- which(corrReddit[,238] > 0.5, arr.ind = T)
reddit_Suicide$reddit_Txt[list_reddit[[1]]]
reddit_Suicide$reddit_Txt[296]


list_reddit[[1]]
summary(terms_Freq$scores)
# Try with entropy
dtm_Reddit = DocumentTermMatrix(corpus3, control = list(wordLengths=c(1,Inf)))
dtm_ent <- lw_logtf(as.matrix(dtm_Reddit))*gw_entropy(as.matrix(dtm_Reddit))
lsa_ent <- lsa(t(dtm_ent))
val_ent <- lsa_ent$dk
corr_ENTReddit <- cor(t(val_ent))


list_ENTreddit <- list()
cnt <- 0
for (i in 1: nrow(reddit_Suicide)){
  tmp1 <- which(corr_ENTReddit[,i] > 0.4, arr.ind = T)
  if(length(tmp1) > 3){
    cnt <- cnt + 1
    list_ENTreddit[[cnt]] <- tmp1
  }
}
reddit_Suicide$reddit_Txt[list_ENTreddit[[2]]]


#Find top tfidf terms and entropy terms
ind <- list_reddit[[1]]
reddit_Suicide$reddit_Txt[ind[1]]
reddit_Suicide$reddit_Txt[ind[4]]
mat_tdm <- as.matrix(tdm.Reddit)
tmd_86_tfidf <- mat_tdm[which(mat_tdm[,ind[1]] > 0 ), ind[1]]
tmd_86_terms <- row.names(mat_tdm[which(mat_tdm[,ind[1]] > 0 ),])
binded_tfidfs <- cbind(tmd_86_terms, tmd_86_tfidf)

tmd_2_tfidf <- mat_tdm[which(mat_tdm[,ind[4]] > 0 ), ind[4]]
tmd_2_terms <- row.names(mat_tdm[which(mat_tdm[,ind[4]] > 0 ),])
binded_2_tfidfs <- cbind(tmd_2_terms, tmd_2_tfidf)

tmd_2_terms[tmd_2_terms %in% tmd_86_terms]

ind[1]
ind[4]

tdm.Reddit = TermDocumentMatrix(corpus3, control = list(weighting = weightTfIdf, wordLengths=c(1,Inf)))
scores <- rowSums(as.matrix(tdm.Reddit))
terms_Freq <- as.data.frame(cbind(row.names(as.matrix(tdm.Reddit)), scores))
terms_Freq$scores <- as.numeric(as.character(terms_Freq$scores))


ncores=detectCores()
cl = makeCluster(25)
registerDoParallel(cl)
start.time = proc.time()

col_num_val <- nrow(corrReddit)
corr_LSA2 <- corrReddit
corr_LSA2[corr_LSA2 < 0.25] <- 0
# .combine = cbind, .init=list(),
doc_Reddit <- list()
for (ii in 1:1){
  doc_LSA_Norm_365 <- list()
  # col_order <- sample(1:col_num_val, col_num_val)
  # corr_LSA2 <- corr_LSA2[c(col_order), c(col_order)]
  # diag(corr_LSA2) <- 0.2
  for(b in 1:1){
    # b = 1
    n = 365
    if (b == 3){
      n = ncol(corrReddit) - 800
    }
    V_indx <- c(1:n)
    indx_corr <- (b-1)*365 + V_indx
    corr_new <- corr_LSA2[indx_corr,indx_corr]
    grph_tmp = graph_from_adjacency_matrix(corr_new, weighted = T, mode = "undirected")
    
    V(grph_tmp)$name <- as.character(V_indx)
    sims <- 30
    max_objs_par <- list()
    res_obj_par <- list()
    doc_indx <- list()
    ind_report <- list()
    j = 1
    cnt.1 <- 0
    while (j <= 100 & n > 30 & cnt.1 < 18){
      # j <- 1
      NF = length(V_indx)
      res_config <- list()
      n <- length(V_indx)
      if(n > 30) {
        oper <- foreach(i=1:sims, .packages = c("tabuSearch", "igraph")) %dopar% {
          
          nos_1 <- sample(5:30, 1) 
          # Then generate nos_1 integers that are between 1 and size of network
          # these are the positions of initial configuration
          x <- sample(1:n, nos_1)
          mat_tmp <- matrix(0, nrow = 1, ncol = length(V_indx))
          mat_tmp[,x] = 1
          # i = 2
          # print(i)
          res <- tabuSearch(size = NF,iters = 5,objFunc = evaluate,
                            config = mat_tmp,listSize = 5,nRestarts = 4)
          res
          
        }
        for (x in 1 : sims){
          # x <- 2
          curr_obj <- which(oper[[x]]$eUtilityKeep > 0.995*max(oper[[x]]$eUtilityKeep))
          max_obj_i <- max(oper[[x]]$eUtilityKeep)
          if(x == 1){
            max_objs_par[[j]] <- max_obj_i
            doc_ind <- which(oper[[x]]$configKeep[curr_obj[1],] > 0 )
            doc_ind2 <- doc_ind
            for (m in 1:length(curr_obj)){
              # m = 25
              if(length(curr_obj) > 1){
                tmp <- which(oper[[x]]$configKeep[curr_obj[m],] > 0 )
                if (length(tmp) > length(doc_ind)) {
                  doc_ind <- tmp
                  # print(tmp)
                }
              }
            }
          } else {
            foo <- max_obj_i
            if(foo > max_objs_par[[j]]){
              max_objs_par[[j]] <- foo
              doc_ind <- which(oper[[x]]$configKeep[curr_obj[1],] > 0 )
              for (m in 1:length(curr_obj)){
                if(length(curr_obj) > 1){
                  tmp <- which(oper[[x]]$configKeep[curr_obj[m],] > 0 )
                  if (length(tmp) > length(doc_ind)) {
                    doc_ind <- tmp
                  }
                }
              }          
              
            }
          }
          
        }
        if(length(doc_ind) < 3){
          cnt.1 <- cnt.1 + 1
          V_indx <- V_indx[!(V_indx %in% V_indx[doc_ind])]
          corr_new <- corr_new[-doc_ind,-doc_ind]
          grph_tmp = graph_from_adjacency_matrix(corr_new, weighted = T, mode = "undirected")
          V(grph_tmp)$name <- as.character(V_indx)
        } else {
          # print(paste("Length of Vindx is ",length(V_indx),sep = "" ))
          doc_indx[[j]] <- V_indx[doc_ind]
          V_indx <- V_indx[!(V_indx %in% doc_indx[[j]])]
          corr_new <- corr_new[-doc_ind,-doc_ind]
          grph_tmp = graph_from_adjacency_matrix(corr_new, weighted = T, mode = "undirected")
          V(grph_tmp)$name <- as.character(V_indx)
          ind_report[[j]] <- doc_indx[[j]] + (b-1)*365 
          j = j + 1
          cnt.1 <- 0
        }
      }
      print(j)
    }
    print(b)
    doc_LSA_Norm_365[[b]] <- ind_report
  }
  doc_Reddit[[ii]] <- doc_LSA_Norm_365
}

end.time = proc.time()
(end.time-start.time)[3]
stopCluster(cl)

check_Reddit_txt <- indxTOcommFUN2(doc_LSA_Norm_365, corr_LSA_Reddit, 200)
table(check_Reddit_txt[,2])

setwd("C:/Users/tomilayo/Documents/Vaccination")

reddit_Original = read.csv('Reddit Comments.csv')
reddit_Original <- reddit_Original[-c(268), ]

TFIDF_Reddit_txt= reddit_Original[, c(1:2)]
# TFIDF_PSE.20$Doc = as.numeric(row.names(TFIDF_PSE.20))
TFIDF_Reddit_txt$Doc = c(1:nrow(TFIDF_Reddit_txt))
colnames(check_Reddit_txt) = c("Doc", "community")
TFIDF_Reddit_txt = merge(TFIDF_Reddit_txt, check_Reddit_txt, "Doc")

#Try with LDA instead
#-----------------------------------------------------------------------------------------------
#-----------------------------------------------------------------------------------------------
#Try with LDA instead
corpus3 <-tm_map(corpus2, content_transformer( function(x) clean_stemmedText(x)))
dtm.unigram_dat = DocumentTermMatrix(corpus3, control=list(wordLengths=c(1,Inf))) #, weighting = weightTfIdf
dtm.unigram_dat = as.matrix(dtm.unigram_dat)
freq <- as.matrix(colSums((dtm.unigram_dat)))
data(dtm.unigram_dat)

burnin <- 4000
iter <- 2000
thin <- 500
seed <-list(2003,5,63,100001,765)
nstart <- 5
best <- TRUE
k <- 30

topc_test <- LDA(dtm.unigram_dat,k, method="Gibbs", control=list(nstart=nstart, seed = seed, best=best, burnin = burnin, iter = iter, thin=thin))
pse_topics <- tidy(topc_test, matrix = "beta")

pse_top_terms <- pse_topics %>%
  group_by(topic) %>%
  top_n(10, beta) %>%
  ungroup() %>%
  arrange(topic, -beta)

pse_top_terms %>%
  mutate(term = reorder(term, beta)) %>%
  ggplot(aes(term, beta, fill = factor(topic))) +
  geom_col(show.legend = FALSE) +
  facet_wrap(~ topic, scales = "free") +
  ggtitle("Top 8 words for each topic")+
  coord_flip()


beta_spread <- pse_topics %>%
  mutate(topic = paste0("topic", topic)) %>%
  spread(topic, beta) %>%
  filter(topic6 > .001 | topic4 > .001) %>%
  mutate(log_ratio = log2(topic6 / topic4))

pse_documents <- tidy(topc_test, matrix = "gamma")

data("dtm.unigram_dat")
tmp = tidy(dtm.unigram_dat) %>%
  filter(document == 295) %>%
  arrange(desc(count))

topc_test.topics <- as.matrix(topics(topc_test))

#top 10 terms in each topic
topc_test.terms <- as.matrix(terms(topc_test,10))

#probabilities associated with each topic assignment
#Useful for seeing how strongly correlated a document
#is with a particular topic
topicProbabilities <- as.data.frame(topc_test@gamma)
# summary(topicProbabilities)
topicProbab_rev <- topicProbabilities
for ( i in 1:nrow(topicProbab_rev)){
  qnt_i <- quantile(topicProbab_rev[i,], probs = 0.25)
  topicProbab_rev[i, topicProbab_rev[i, ] <= as.numeric(qnt_i)] <- 0
}
corr_LDAReddit <- cor(t(topicProbab_rev))
# Running Tabusearch on Reddit comments
col_num_val <- nrow(corr_LDAReddit)
corrLDARed_tmp <- corr_LDAReddit
corrLDARed_tmp[corrLDARed_tmp < 0.15] <- 0

list_redditLDA <- list()
cnt <- 0
for (i in 1: nrow(reddit_Suicide)){
  tmp1 <- which(corrLDARed_tmp[,i] > 0.7, arr.ind = T)
  if(length(tmp1) > 3){
    cnt <- cnt + 1
    list_redditLDA[[cnt]] <- tmp1
  }
}

list_redditLDA[[1]]
# Find groups of documents that are similar
tmp1 <- which(corrLDARed_tmp[,238] > 0.5, arr.ind = T)
reddit_Suicide$reddit_Txt[list_redditLDA[[2]]]
reddit_Suicide$reddit_Txt[296]


ncores=detectCores()
cl = makeCluster(25)
registerDoParallel(cl)
start.time = proc.time()

col_num_val <- nrow(corrLDARed_tmp)
corr_LSA2 <- corrLDARed_tmp
corr_LSA2[corr_LSA2 < 0.25] <- 0
# .combine = cbind, .init=list(),
doc_LDAReddit <- list()
for (ii in 1:1){
  doc_LSA_Norm_365 <- list()
  # col_order <- sample(1:col_num_val, col_num_val)
  # corr_LSA2 <- corr_LSA2[c(col_order), c(col_order)]
  # diag(corr_LSA2) <- 0.2
  for(b in 1:1){
    # b = 1
    n = 365
    if (b == 3){
      n = ncol(corrLDARed_tmp) - 800
    }
    V_indx <- c(1:n)
    indx_corr <- (b-1)*365 + V_indx
    corr_new <- corr_LSA2[indx_corr,indx_corr]
    grph_tmp = graph_from_adjacency_matrix(corr_new, weighted = T, mode = "undirected")
    
    V(grph_tmp)$name <- as.character(V_indx)
    sims <- 30
    max_objs_par <- list()
    res_obj_par <- list()
    doc_indx <- list()
    ind_report <- list()
    j = 1
    cnt.1 <- 0
    while (j <= 100 & n > 30 & cnt.1 < 18){
      # j <- 1
      NF = length(V_indx)
      res_config <- list()
      n <- length(V_indx)
      if(n > 30) {
        oper <- foreach(i=1:sims, .packages = c("tabuSearch", "igraph")) %dopar% {
          
          nos_1 <- sample(5:30, 1) 
          # Then generate nos_1 integers that are between 1 and size of network
          # these are the positions of initial configuration
          x <- sample(1:n, nos_1)
          mat_tmp <- matrix(0, nrow = 1, ncol = length(V_indx))
          mat_tmp[,x] = 1
          # i = 2
          # print(i)
          res <- tabuSearch(size = NF,iters = 5,objFunc = evaluate,
                            config = mat_tmp,listSize = 5,nRestarts = 4)
          res
          
        }
        for (x in 1 : sims){
          # x <- 2
          curr_obj <- which(oper[[x]]$eUtilityKeep > 0.995*max(oper[[x]]$eUtilityKeep))
          max_obj_i <- max(oper[[x]]$eUtilityKeep)
          if(x == 1){
            max_objs_par[[j]] <- max_obj_i
            doc_ind <- which(oper[[x]]$configKeep[curr_obj[1],] > 0 )
            doc_ind2 <- doc_ind
            for (m in 1:length(curr_obj)){
              # m = 25
              if(length(curr_obj) > 1){
                tmp <- which(oper[[x]]$configKeep[curr_obj[m],] > 0 )
                if (length(tmp) > length(doc_ind)) {
                  doc_ind <- tmp
                  # print(tmp)
                }
              }
            }
          } else {
            foo <- max_obj_i
            if(foo > max_objs_par[[j]]){
              max_objs_par[[j]] <- foo
              doc_ind <- which(oper[[x]]$configKeep[curr_obj[1],] > 0 )
              for (m in 1:length(curr_obj)){
                if(length(curr_obj) > 1){
                  tmp <- which(oper[[x]]$configKeep[curr_obj[m],] > 0 )
                  if (length(tmp) > length(doc_ind)) {
                    doc_ind <- tmp
                  }
                }
              }          
              
            }
          }
          
        }
        if(length(doc_ind) < 3){
          cnt.1 <- cnt.1 + 1
          V_indx <- V_indx[!(V_indx %in% V_indx[doc_ind])]
          corr_new <- corr_new[-doc_ind,-doc_ind]
          grph_tmp = graph_from_adjacency_matrix(corr_new, weighted = T, mode = "undirected")
          V(grph_tmp)$name <- as.character(V_indx)
        } else {
          # print(paste("Length of Vindx is ",length(V_indx),sep = "" ))
          doc_indx[[j]] <- V_indx[doc_ind]
          V_indx <- V_indx[!(V_indx %in% doc_indx[[j]])]
          corr_new <- corr_new[-doc_ind,-doc_ind]
          grph_tmp = graph_from_adjacency_matrix(corr_new, weighted = T, mode = "undirected")
          V(grph_tmp)$name <- as.character(V_indx)
          ind_report[[j]] <- doc_indx[[j]] + (b-1)*365 
          j = j + 1
          cnt.1 <- 0
        }
      }
      print(j)
    }
    print(b)
    doc_LSA_Norm_365[[b]] <- ind_report
  }
  doc_LDAReddit[[ii]] <- doc_LSA_Norm_365
}

end.time = proc.time()
(end.time-start.time)[3]
stopCluster(cl)

check_LDAReddit <- indxTOcommFUN2(doc_LDAReddit[[1]], corrLDARed_tmp, 200)

LDA_Reddit_txt= reddit_Original[, c(1:2)]
# TFIDF_PSE.20$Doc = as.numeric(row.names(TFIDF_PSE.20))
LDA_Reddit_txt$Doc = c(1:nrow(LDA_Reddit_txt))
colnames(check_LDAReddit) = c("Doc", "community")
LDA_Reddit_txt = merge(LDA_Reddit_txt, check_LDAReddit, "Doc")

#-----------------------------------------------------------------------------------------------
#-----------------------------------------------------------------------------------------------
